!function(global, factory) {
    "object" == typeof exports && "undefined" != typeof module ? module.exports = factory(require("preact")) : "function" == typeof define && define.amd ? define([ "preact" ], factory) : global.wire = factory(global.preact);
}(this, function(preact) {
    "use strict";
    function dlv(obj, key, def, p) {
        for (p = 0, key = key.split ? key.split(".") : key; obj && p < key.length; ) obj = obj[key[p++]];
        return void 0 === obj ? def : obj;
    }
    function join(arr) {
        return arr ? arr.join("\n") : "";
    }
    function get(obj, key) {
        return key ? obj[key] : obj;
    }
    function shallowEqual(a, b) {
        for (var key in a) if (a[key] !== b[key]) return !1;
        for (var key$1 in b) if (!(key$1 in a)) return !1;
        return !0;
    }
    function removeKeyFromObject(key, obj) {
        return obj.hasOwnProperty(key) && (obj = assign({}, obj), delete obj[key]), Object.keys(obj).length ? obj : void 0;
    }
    function noop() {}
    function assign(obj) {
        for (var arguments$1 = arguments, i = 1; i < arguments.length; i++) for (var p in arguments[i]) obj[p] = arguments$1[i][p];
        return obj;
    }
    function wire(contextNamespace, mapToProps, mapModelToProps) {
        void 0 === mapToProps && (mapToProps = {}), void 0 === mapModelToProps && (mapModelToProps = noop);
        var CACHE = {};
        return function(Child) {
            return function(Component$$1) {
                function WireDataWrapper(props, context) {
                    var this$1 = this;
                    Component$$1.call(this, props, context), this.state = {}, this.currentKeys = {}, 
                    this.tracking = {}, this.counter = 0, this.mapping = mapModelToProps(get(context, contextNamespace), props), 
                    this.refresh = function() {
                        this$1.invoke(this$1.props, !1, !0);
                    };
                }
                return Component$$1 && (WireDataWrapper.__proto__ = Component$$1), WireDataWrapper.prototype = Object.create(Component$$1 && Component$$1.prototype), 
                WireDataWrapper.prototype.constructor = WireDataWrapper, WireDataWrapper.prototype.shouldComponentUpdate = function(props, state) {
                    return !shallowEqual(props, this.props) || !shallowEqual(state, this.state);
                }, WireDataWrapper.prototype.invoke = function(props, keysOnly, refresh) {
                    var this$1 = this, source = get(this.context, contextNamespace), isFunction = "function" == typeof mapToProps, mapping = isFunction ? mapToProps(props) : mapToProps, keys = [];
                    for (var prop in mapping) !function(prop) {
                        if (mapping.hasOwnProperty(prop)) {
                            var path = mapping[prop], args = [];
                            Array.isArray(path) && (args = path.slice(1), path = path[0]), isFunction || (args = args.map(function(p) {
                                return "string" == typeof p && p in props ? props[p] : p;
                            }));
                            var key = JSON.stringify([ contextNamespace, path ].concat(args));
                            if (keys.push(key), keysOnly) return;
                            if (!refresh && this$1.currentKeys[prop] === key) return;
                            this$1.currentKeys[prop] = key;
                            var p = void 0;
                            if ("function" == typeof path) p = path(); else if ("string" != typeof path) p = path; else {
                                var fn = dlv(source, path);
                                if (!fn) throw Error(contextNamespace + "." + path + " not found.");
                                p = fn.apply(void 0, args);
                            }
                            if (p && void 0 !== p.then && p.__wiretieResolved && (p = p.__wiretieResolved), 
                            p && void 0 !== p.then) {
                                var newState = {}, ref = this$1.state, pending = ref.pending, rejected = ref.rejected;
                                if (pending) {
                                    if (!pending[prop]) {
                                        newState.pending = (obj$1 = assign({}, pending), obj$1[prop] = !0, obj$1);
                                        var obj$1;
                                    }
                                } else {
                                    newState.pending = (obj = {}, obj[prop] = !0, obj);
                                    var obj;
                                }
                                rejected && rejected[prop] && (newState.rejected = removeKeyFromObject(prop, rejected));
                                var id = ++this$1.counter;
                                this$1.tracking[prop] = id, p.then(function(data) {
                                    p.__wiretieResolved = data;
                                    var newState = {};
                                    return newState[prop] = CACHE[key] = data, newState;
                                }).catch(function(err) {
                                    if (this$1.tracking[prop] === id) {
                                        var rejected = this$1.state.rejected && assign({}, this$1.state.rejected) || {};
                                        rejected[prop] = err;
                                        var newState = {
                                            rejected: rejected
                                        };
                                        return CACHE[key] && (newState[prop] = CACHE[key]), newState;
                                    }
                                }).then(function(newState) {
                                    if (this$1.tracking[prop] === id) {
                                        delete this$1.tracking[prop];
                                        var pending = this$1.state.pending;
                                        pending && pending[prop] && (newState.pending = removeKeyFromObject(prop, pending)), 
                                        this$1.setState(newState);
                                    }
                                }), void 0 !== CACHE[key] && (newState[prop] = CACHE[key]), this$1.setState(newState);
                            } else {
                                this$1.setState((obj$2 = {}, obj$2[prop] = p, obj$2));
                                var obj$2;
                            }
                        }
                    }(prop);
                    return this.keys = keys;
                }, WireDataWrapper.prototype.componentWillMount = function() {
                    this.invoke(this.props);
                }, WireDataWrapper.prototype.componentWillReceiveProps = function(nextProps) {
                    shallowEqual(nextProps, this.props) || join(this.keys) === join(this.invoke(nextProps, !0)) || this.invoke(nextProps);
                }, WireDataWrapper.prototype.render = function(props, state) {
                    return preact.h(Child, assign({}, {
                        refresh: this.refresh
                    }, this.mapping, props, state));
                }, WireDataWrapper;
            }(preact.Component);
        };
    }
    return wire;
});
//# sourceMappingURL=wiretie.js.map